package com.example.bgndtgramtrackershmelev;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;

import android.Manifest;
import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.hardware.SensorEvent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.telephony.SmsManager;
import android.text.format.DateFormat;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.net.MalformedURLException;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import javax.net.ssl.HttpsURLConnection;

//-------------------------------------------------
// This BGndGPSTracker app
// Определяет координаты по GPS и по Network (базовым станциям), показывает высоту, рассчитывает направление между двумя точками
// SMS-трекер, который каждые 30 минут будет отправлять координаты на указанный телефон
// Может работать в бэкграунде
// Приложение будет дополнено модулем работы с картами Google и возможностью отправлять данные в Telegram канал
//
// Проект содержит все необходимые файлы и готов к компилированию и установке на самртфон
//
// Номер телефона для отправки SMS с координатами указывается в программе жестко.
// Номер телефона в формате 81019213767
//
// Разрешено использовать проект в коммерческих или не коммерческих целях. Требуется соблюдать действующее законодательство.
// Просьба указывать ссылку на первоисточник - данный проект и автора. Это только пожелание.
//
// Данный проект приложения предлагается "как есть". JAVA код не оптимален. Проект регулярно дорабатывается, функционал - расширяется.
// Это приложение - отличный вариант для курсовой работы или для презентации при поиске работы.
//
// Проект разрабатывался в Android Studio
//
// Android Studio Electric Eel | 2022.1.1 Patch 1
// Build #AI-221.6008.13.2211.9514443, built on January 21, 2023
// Runtime version: 11.0.15+0-b2043.56-9505619 amd64
// VM: OpenJDK 64-Bit Server VM by JetBrains s.r.o.
// Windows 10 10.0
// GC: G1 Young Generation, G1 Old Generation
// Memory: 1280M
// Cores: 8
//
// Для отладки приложения использовался смартфон Samsung M21, подключенный через USB шнур
//
// Для более простой работы с проектом разместите его в папке
// C:\Users\vall\AndroidStudioProjects\BGndGPSTrackerSHMELEV
// Windows пользователь vall (login)
// В этом случае в проект придется вносить меньше правок при запуске
//
// (c) by Valery Shmelev (Oflameron) https://www.linkedin.com/in/valery-shmelev-479206227/
// GitHUB Repository  https://github.com/vallshmeleff
//
//-------------------------------------------------
//
// Данное приложение - демонстратор технологий. Всё работает - определяются координаты по GPS и Базовым Станциям, отправляются с SMS или в Telegram-канал.
// Но для коммерческой версии нужны дополнительные функции - ввод и сохранение настроек (ID-канала, токен, номер телефона). Здесь это не сделано специально, чтобы не усложнять восприятие проекта.
// Данный проект - полностью готовый курсовой проект или демонстратор при поиске работы в качестве Android Developer
//
// На базе этого проекта будет разработан и опубликован в исходных кодах проект коммерческого Трекера с полным функционалом.
//
//-------------------------------------------------

public class MainActivity extends AppCompatActivity {
    TextView tvEnabledGPS;
    TextView tvStatusGPS;
    TextView tvLocationGPS;
    TextView tvEnabledNet;
    TextView tvStatusNet;
    TextView tvLocationNet;
    TextView tvAltitude;
    TextView tvAzimut;
    TextView Coord4Azimut; // Координаты начала и конца азимута
    TextView tvGSMSpeed;
    TextView tvCalcSpeed;
    public static EditText number;
    public static TextView SMSTg; // Выбран режим отправки SMS или Telegram
    public static int smstg = 0; // Режим отправки черерз SMS. Если =1, то отправка в Telegram
    private LocationManager locationManager;
    StringBuilder sbGPS = new StringBuilder();
    StringBuilder sbNet = new StringBuilder();

    public double sorseLat = 0; // Где вы сейчас
    public double sorseLong = 0; // Где вы сейчас
    public double sorseLat2 = 0; // Предыдущее значение координаты (сохраненное)
    public double sorseLong2 = 0; // Предыдущее значение координаты (сохраненное)
    public double OldTime = 0; // Время
    public double NewTime = 0.1;

    public float azimuth; // Азимут
    public float baseAzimuth;
    private final static int SEND_SMS_PERMISSION_REQ=1;
    public static String GeoPositionSMS="Current Geo Pos: APP STARTED"; // Текст для формирования SMS
    public static String CurrentSpeed =""; // Текст для формирования SMS
    public static int YLoc; // =1 Если определение позиции доступно
    Timer timer;
    TimerTask mTimerTask;
    public static String numberText; // Номер телефона
    public static String messageText; // Текст SMS сообщения
    public static Context Maincontext;
    public static Context context;
    public static int SheduleTrig = 1; // Триггер =0 (Timer еще не стартовал), = 1 (Timer стартовал)
    public static int ehh = 0; // счетчик SMS
    //---- Telegram --------------------------------
    public String tlf = "84671043973"; // Телефон, на который отправлять SMS
    public String id = "5945098610"; // ID Telegram-канала
                                     // Как получить идентификатор Telegram-канала: наберите в поисковике "узнать ID telegram канала"
    public String token = "7107884651:AAGKV5qP4QCGetjTlFXGk325mbZsej124Bk"; // Токен Telegram-канала для работы с ним
                                                                            // Задайте в поиск на Yndex или Google "Как получить токен для подключения Telegram"
    public String MessageToTelegram = "Text message: GPS Coordinates"; // Тестовое сообщение, отправляемое в Telegram-канал

    @SuppressLint("MissingInflatedId")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Maincontext = getApplicationContext(); // Для работы с context

        //----- Telegram --------------
        SendMessageTelegram SendText = new SendMessageTelegram(); // Экземпляр класса
        new SendMessageTelegram().execute(); // Отправить текстовое сообщение в Telegram-канал. Только текст. Файлы или картинки так отправить нельзя.
        // Если канала в Telegram нет - ситуация в данном демонстраторе технологий НЕ ОБРАБАТЫВАЕТСЯ. Может вызвать ощибку
        //----- Таймер ----------------
        timer = new Timer();
        mTimerTask = new MyTimerTask();
        // Если в приложении не установлен номер телефона, то будет ошибка
        //----------------------------

        tvEnabledGPS = (TextView) findViewById(R.id.tvEnabledGPS);
        tvStatusGPS = (TextView) findViewById(R.id.tvStatusGPS);
        tvLocationGPS = (TextView) findViewById(R.id.tvLocationGPS); // GPS Позиция
        tvEnabledNet = (TextView) findViewById(R.id.tvEnabledNet);
        tvStatusNet = (TextView) findViewById(R.id.tvStatusNet);
        tvLocationNet = (TextView) findViewById(R.id.tvLocationNet); // Позиция, определенная по base stations
        tvAltitude = (TextView) findViewById(R.id.tvAltitude); // Высота над уровнем моря
        Coord4Azimut = (TextView) findViewById(R.id.Coord4Azimut); // Bearing
        tvAzimut = (TextView) findViewById(R.id.tvAzimut);
        tvGSMSpeed = (TextView) findViewById(R.id.tvGSMSpeed);
        tvCalcSpeed = (TextView) findViewById(R.id.tvCalcSpeed); // Скорость, вычисленная по изменению координат
        number = (EditText) findViewById(R.id.number); // Номер телефона в формате 81019213767
        number.setText(tlf); // Показать номер телефона
        SMSTg = (TextView) findViewById(R.id.tvSMSTg); // Выбран режим отправки SMS или Telegram
        SMSTg.setText("NOW send to SMS");
        TextView cxtv = findViewById(R.id.TopPicture); // Верхняя картинка приложения
        cxtv.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.toppicture, 0, 0);

        YLoc =0;
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT); //Задать статично ориентацию экрана
        //--------- Не переходить к режиму SLEEP ------------------------
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        //---------------------------------------------------------------
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.SEND_SMS}, SEND_SMS_PERMISSION_REQ); // SMS Permissions
        Coord4Azimut.setText("Bearing for : \n Dest Latitude : " + "\n Dest Longitude : " +  "\n This Latitude : " +  "\n Dest Longitude : ");

    }  // OnCreate

    // Отображаем информацию в текстовом поле count:
    public void run() {
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
            // TODO: Consider calling
            //    ActivityCompat#requestPermissions
            // here to request the missing permissions, and then overriding
            //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
            //                                          int[] grantResults)
            // to handle the case where the user grants the permission. See the documentation
            // for ActivityCompat#requestPermissions for more details.
            return;
        }
        locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
                1000 * 10, 10, locationListener);
        locationManager.requestLocationUpdates(
                LocationManager.NETWORK_PROVIDER, 1000 * 10, 10,
                locationListener);
        checkEnabled();
    }

    @Override
    protected void onPause() {
        super.onPause();
        locationManager.removeUpdates(locationListener);
    }

    private LocationListener locationListener = new LocationListener() {

        @Override
        public void onLocationChanged(Location location) {
            showLocation(location);
        }

        @Override
        public void onProviderDisabled(String provider) {
            checkEnabled();
        }

        @Override
        public void onProviderEnabled(String provider) {
            checkEnabled();
            Log.i("CHECK ENABLE 0", " == == onProviderEnabled == == ");
            if (ActivityCompat.checkSelfPermission(getApplicationContext(), android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(getApplicationContext(), android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                // TODO: Consider calling
                //    ActivityCompat#requestPermissions
                // here to request the missing permissions, and then overriding
                //   public void onRequestPermissionsResult(int requestCode, String[] permissions,
                //                                          int[] grantResults)
                // to handle the case where the user grants the permission. See the documentation
                // for ActivityCompat#requestPermissions for more details.
                return;
            }

        }

        @Override @SuppressWarnings("deprecation")
        public void onStatusChanged(String provider, int status, Bundle extras) {
            if (provider.equals(LocationManager.GPS_PROVIDER)) { // По GPS
                tvStatusGPS.setText("Status %: " + String.valueOf(status));
            } else if (provider.equals(LocationManager.NETWORK_PROVIDER)) { // По Базовым Станциям
                tvStatusNet.setText("Status %: " + String.valueOf(status));
            }
        }
    };

    public void onSensorChanged(SensorEvent event) {
        azimuth = event.values[0];
        baseAzimuth = azimuth;
    }

    private void showLocation(Location location) {
        double currentSpeed,kmphSpeed;
        if (location == null)
            return;
        if (location.getProvider().equals(LocationManager.NETWORK_PROVIDER)) {
            //if (location.getProvider().equals(LocationManager.GPS_PROVIDER)) { // Если использовать эту строку, то по GPS
            //if (location.getProvider().equals(LocationManager.NETWORK_PROVIDER)) { // Если использовать эту строку, то по Базовым Станциям

            //= onTimer(); // Запустить Timer сразу после того, как приложение запущено и доступны источники координат

            tvLocationGPS.setText(formatLocation(location));
            tvAltitude.setText("Altitude: " + location.getAltitude());
            // location.getAccuracy() - Чем меньше возвращаемое число, тем выше точность
            // bearingTo - bearingTo(Location dest) - Показывает направление на указанную точку назначения
            //
            sorseLat2 = sorseLat; // Где вы сейчас — предыдущее значение
            sorseLong2 = sorseLong; // Где вы сейчас — предыдущее значение
            OldTime = NewTime; // Сохранить Time
            NewTime = location.getTime(); // Новое значение Time

            sorseLat = location.getLatitude(); // Где вы сейчас
            sorseLong = location.getLongitude(); // Где вы сейчас

            //------ В этом примере пункт назначения задается числами. --------
            double destLat = 65.9242; // Координаты места назначения, для вычисления направления
            double destLong = 47.8593;
            Coord4Azimut.setText("Bearing : \n Dest Latitude : " + String.valueOf(destLat) +  "\n Dest Longitude : " + String.valueOf(destLong) +  "\n This Latitude : " + String.valueOf(sorseLat) +  "\n Dest Longitude : " + String.valueOf(sorseLong));

            Location from = new Location(LocationManager.GPS_PROVIDER);
            Location to = new Location(LocationManager.GPS_PROVIDER);
            from.setLatitude(sorseLat); // Текущая позиция
            from.setLongitude(sorseLong);
            to.setLatitude(destLat); // Место назначения
            to.setLongitude(destLong);
            //------ Вычисляем азимут (направление) --------
            float bearingTo = from.bearingTo(to);
            Coord4Azimut.setText("GPS Bearing :" + String.valueOf(bearingTo));
            // В расчетах принята форма Земли как идеальный шар. Нет учета несферичности и перепада высот
            //------ Скорость по GPS --------
            if (location.hasSpeed()) {
                double speed = location.getSpeed();
                currentSpeed = round(speed,3,BigDecimal.ROUND_HALF_UP);
                kmphSpeed = round((currentSpeed*3.6),3,BigDecimal.ROUND_HALF_UP);
                tvGSMSpeed.setText("GPS Speed :" + String.valueOf(kmphSpeed));
                CurrentSpeed = String.valueOf(kmphSpeed); // For SMS
            } else {
                tvGSMSpeed.setText("GPS Speed : No data");
                //------ Рассчитываеме скорость по изменению координат GPS --------
                //------ Временно отключено. Возможно, дает ошибку ------------------
                //= double radius = 6371000;
                //= double dLat = Math.toRadians(sorseLat-sorseLat2);
                //= double dLon = Math.toRadians(sorseLong-sorseLong2);
                //= double a = Math.sin(dLat/2) * Math.sin(dLat/2) +
                //=         Math.cos(Math.toRadians(sorseLat)) * Math.cos(Math.toRadians(sorseLat2)) *
                //=                 Math.sin(dLon/2) * Math.sin(dLon/2);
                //= double c = 2 * Math.asin(Math.sqrt(a));
                //= double distance =  Math.round(radius * c);

                //= double timeDifferent = NewTime - OldTime;
                //= tvCalcSpeed.setText("Calc Speed : " + String.valueOf(distance/timeDifferent));

            }

        } else if (location.getProvider().equals(
                LocationManager.NETWORK_PROVIDER)) {
            tvLocationNet.setText(formatLocation(location));
            tvAltitude.setText("Altitude: " + location.getAltitude());
        }
        GeoPositionSMS = GeoPositionSMS + " " + formatLocation(location).toString() + " Current Speed: " + CurrentSpeed; // Для отправки в SMS
    }

    public static double round(double unrounded, int precision, int roundingMode) {
        BigDecimal bd = new BigDecimal(unrounded);
        BigDecimal rounded = bd.setScale(precision, roundingMode);
        return rounded.doubleValue();
    }

    private String formatLocation(Location location) {
        if (location == null)
            return "";
        return String.format(
                "Source Coordinates: lat = %1$.4f, lon = %2$.4f, time = %3$tF %3$tT",
                location.getLatitude(), location.getLongitude(),
                location.getTime());
    }

    private void checkEnabled() {
        tvEnabledGPS.setText("Enabled: "
                + locationManager
                .isProviderEnabled(LocationManager.GPS_PROVIDER)); // Доступны данные с GPS
        tvEnabledNet.setText("Enabled: "
                + locationManager
                .isProviderEnabled(LocationManager.NETWORK_PROVIDER)); // Доступны данные с Базовых Станций
    }

    public void onClickLocationSettings(View view) {
        startActivity(new Intent(
                android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS));
    };


    //------------------- SMS ---------------------------------
    public void dial() {
        SendMessageTelegram SendText = new SendMessageTelegram(); // Экземпляр класса
        MainActivity MActivity = new MainActivity();
        ehh++; // Счетчик SMS
        Date d = new Date();
        CharSequence s = DateFormat.format("yyyy-MM-dd hh:mm:ss", d.getTime()); // Получить дату и время в определнном формате

        MActivity.numberText = tlf; // Номер телефдна MActivity.number.getText().toString();
        MActivity.messageText= MActivity.GeoPositionSMS; // message.getText().toString();
        String SMSMess = MActivity.messageText.toString();
        // Отправка
        if (smstg == 0) { // Отправка через SMS
            SmsManager.getDefault().sendTextMessage(numberText, null, SMSMess, null, null);
        }
        if (smstg == 1) { // Отправка в Telegram
            SendText.execute();
        }

        Log.d("= Dial =", "==== SMS Send ====: " + String.valueOf(ehh) + s.toString()); // Счетчик SMS
    }

    //---------------- Нажата кнопка START --------------
    public void onClickStart(View view) {
        SheduleTrig = 0; // Разрешить Таймер
        onTimer(); // Запустить Timer
        SheduleTrig = 1; // Запретить Таймер
        Button btnsmstg = (Button)findViewById(R.id.btnSMSTg); // SMS или Telegram
        btnsmstg.setEnabled(false); // Отключить кнопку btnSMSTg
        Button btnlocationsetting = (Button)findViewById(R.id.btnLocationSettings); // Переход к настройкам в Android
        btnlocationsetting.setEnabled(false); // Отключить кнопку перехода к настройкам Android

    }

    //---------------- Выбор SMS или Telegram ----------
    public void onClickSmsTg(View view) {
    if (smstg == 0){ // Был режим отправки через SMS
        smstg = 1; // Выбрать режим отправки в Telegram
        SMSTg.setText("NOW send to Telegram");
        SMSTg.setBackgroundColor(Color.parseColor("#00782D"));
        SMSTg.setTextColor(Color.parseColor("#FFFFFF"));
    }else{ // Был режим отправки в Telegram
        smstg = 0; // Выбрать режим отправки через SMS
        SMSTg.setText("NOW send to SMS");
        SMSTg.setBackgroundColor(Color.parseColor("#FF4100"));
        SMSTg.setTextColor(Color.parseColor("#FFFFFF"));
    }
    }

    //---------------- Таймер ---------------------------
    public void onTimer() {
        if (SheduleTrig == 0) {
            timer.schedule(mTimerTask, 0, 120000); // Отправлять 1 раз в 20 минут = 1200000
            SheduleTrig = 1; // Timer запущен. Не запускать еще раз
        }
    } //---------------- Таймер ---------------------------------

    //---------------- Выйти из приложения --------------------
    public void onButtonExit(View arg0) {
        moveTaskToBack(true);
        android.os.Process.killProcess(android.os.Process.myPid());
        System.exit(1);
    }
    //----------------------- ---------------------------------

    class MyTimerTask extends TimerTask {
        public int TCounter = 0; // Счетчик SMS

        @Override
        public void run() {
            runOnUiThread(new Runnable() {
                // Отображаем информацию в Log d
                @Override
                public void run() {
                    TCounter = TCounter +1;
                    String STCounter = String.valueOf(TCounter);
                    Log.d("= runOnUiThread =", "==== Timer ====: " + STCounter); // Пишем значения счетчика для таймера 1
                    MainActivity MActivity = new MainActivity();
                    MActivity.dial(); // Отправить SMS
                }
            });
        }
    }




    //=====внутренний класс передачи сообщений в интернет на канал telegram=============
    private  class SendMessageTelegram extends AsyncTask<Void, Void, Void> {
        private String resultString = null;
        //метод для отображения индикатора выполнения в пользовательском интерфейсе
        //не используется
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }
        // метод для выполнения задач в фоновом режиме
        @Override
        protected Void doInBackground(Void... voids) {
            try {
                //адрес бота "телеграмм"
                String myURL = "https://api.telegram.org/bot" + token +"/sendMessage";
                String param = "chat_id=" + id + "&text=" + GeoPositionSMS;
                byte[] data;
                try {//подключаемся к серверу
                    URL url = new URL(myURL);
                    HttpsURLConnection conn = (HttpsURLConnection) url.openConnection();
                    conn.setReadTimeout(5000);//тайм-аут чтения в мс
                    conn.setConnectTimeout(10000);//тайм-аут соединения в мс
                    conn.setRequestMethod("POST");
                    conn.setDoOutput(true);
                    conn.setDoInput(true);
                    //задать общее свойство запроса:
                    // - повторное использование соединений HTTP "Keep-Alive";
                    // - тип формата отправки запроса по умолчанию (можно не указывать)
                    conn.setRequestProperty("Connection", "Keep-Alive");
                    conn.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
                    //определяем длину передаваемого сообщения
                    conn.setRequestProperty("Content-Length", Integer.toString(param.getBytes().length));
                    OutputStream os = conn.getOutputStream();
                    // конвертируем передаваемую строку в UTF-8
                    data = param.getBytes(StandardCharsets.UTF_8);
                    //передаем данные на сервер
                    os.write(data);
                    os.flush();
                    os.close();
                    conn.connect();
                    int responseCode = conn.getResponseCode();//Представляющие три цифры HTTP Status-Code
                    resultString = Integer.toString(responseCode);
                    conn.disconnect();//отключение соединения
                } catch (MalformedURLException e) {//неправильный адрес сайта
                    Log.d("== == ERROR == ==", "====== Неправильный адрес сайта ====== " + e.getMessage());
                    resultString = "MalformedURLException:" + e.getMessage();
                } catch (IOException e) {//неудачная операция ввода/вывода
                    Log.d("== == ERROR == ==", "====== Неудачная операция ввода/вывода ====== " + e.getMessage());
                    resultString = "IOException:" + e.getMessage();
                } catch (Exception e) {//что-то пошло не так
                    Log.d("== == ERROR == ==", "====== Что-то пошло не так ====== " + e.getMessage());
                    resultString = "Exception:" + e.getMessage();
                }
            } catch (Exception e) {
                //e.printStackTrace();
            }
            return null;
        }
        // метод для обработки результата выполнения фоновых задач
        @Override
        protected void onPostExecute(Void result) {
            super.onPostExecute(result);
            // для отладки
            if (resultString != null) {
                //вывод результата на экран
                //=Toast.makeText(MainActivity.this, resultString, Toast.LENGTH_LONG).show();
            } else {
                //=Toast.makeText(MainActivity.this, "no result", Toast.LENGTH_SHORT).show();
            }
            if (resultString.equals("200")) {//kod '200' - ok сообщение доставлено успешно
                //=Toast.makeText(MainActivity.this, "СООБЩЕНИЕ:" +
                //=MessageToTelegram  + "\r\n" + " ОТПРАВЛЕНО  B TELEGRAM", Toast.LENGTH_LONG).show();
            } else {
                //=Toast.makeText(MainActivity.this, "СООБЩЕНИЕ:" +
                //=MessageToTelegram  + "\r\n" + " ОШИБКА отправки ИНТЕРНЕТ ", Toast.LENGTH_LONG).show();
            }
        }
    }


} // MainActivity


//
// Другие интересные приложения:
// - генератор псевдослучайных чисел большой размерности - 1024 bit или больше.
//   Генератор основан на известном криптографически стойком алгоритме Blum-Blum-Shub, но намеренно сделан НЕ КРИПТОГРАФИЧЕСКИМ,
//   чтобы не нарушать законодательные ограничения. Хотя качество генерирруемых чисел очень хорошее.
//   Это только генератор чисел, ничего не шифрует.
// - приграмма для подбора простых чисел большрй размерности (например, 1024 bit) для алгоритма Blum-Blum-Shub. Приложение делает только подбирает пары чисел.
//   Ничего не шифрует.
// - трекер с отправкой координат, вычисленных по GPS или Базовым Станциям через SMS или прямо в Telegram канал.
//   Может вычислять скорость.
//   Удобно держать в курсе своих родных или друзей.
//
//  Application AudioREG for Android (c) by Valery Shmelev
//  https://www.linkedin.com/in/valery-shmelev-479206227/
//
